.nolist
include \masm32\include\masm32rt.inc
.XMM

BufLen	EQU 40000h ; not a lot... but for 100000h it takes ML.exe over 2 minutes!

.data?
buffer db BufLen dup(?)

COMMENT @ ^ ^ Here is trouble. Assembly (ml.exe) times:

100000h	2 MINUTES
80000h	9 secs
80000h	6 secs
60000h	3 secs
40000h	2 secs
4000h	0 secs

@

; ORIGIN: NightWare, http://www.masm32.com/board/index.php?topic=7458.msg55160#msg55160

; effacer un bloc memoire (en le remplissant de 0)
; note : le bloc mmoire n'a pas besoin d'tre align sur 16 octets, et XMM0 est modifi
;
; Rceptionne :
; eax = taille  ffacer en octets
; esi = adresse du bloc de destination
;
; Retourne : rien
;
; syntaxe :
; mov eax,Size
; mov esi,StartingAddress
; call Sse_ZeroMem_UnAligned

.code
ALIGN 16

start:	push esi
	.if 1
		mov esi, offset buffer
		mov eax, BufLen
		call Sse_ZeroMem_UnAligned
	.endif
	pop esi

	invoke MessageBox, 0, chr$("Done"), chr$("SSE test"), MB_OK

	exit

Sse_ZeroMem_UnAligned PROC
push ebx	;  empiler ebx
push ecx	;  empiler ecx

; premirement on va s'assurer que la taille minimale est atteinte, sinon on va directement traiter les dwords
xor ebx,ebx	;  effacer ebx (ca doit tre fait ici, pour que tout fonctionne normalement)
cmp eax,00000000000000000000000000001111b	;  comparer eax  15
jbe Label09	;  si c'est infrieur ou gal, aller Label09

;
; ici, on s'occupe de la partie non aligne
;
mov ecx,esi	;  copier l'adresse de dpart dans ecx
and ecx,00000000000000000000000000001111b	;  enlever les OWORDs en ecx
jz Label05	;  si ecx est gal  zro (c'est dj align), aller Label05
mov ebx,00000000000000000000000000010000b	;  sinon, placer 16 (ben oui, ici il faut tenir compte du 0 qui ne sera pas trait) dans ebx
sub ebx,ecx	;  enlever ecx  ebx
sub eax,ebx	;  enlever ebx (la partie non aligne)  eax (la taille originelle)
; ici on traite les octets du dbut (on commence par les octets, pour bnficier d'un meilleur alignement avec les dwords)
Label01: mov ecx,ebx	;  placer la taille  copier dans ecx
and ecx,00000000000000000000000000000011b	;  ne conserver que les bits octets en ecx
jz Label03	;  si ecx est gal  0, aller Label03
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
Label02: mov BYTE PTR [esi+ecx],0	;  placer 0 en esi+ecx
inc ecx	;  on ajoute 1  ecx (notre pas de boucle)
jnz Label02	;  tant que ecx est diffrent de 0, aller Label02
; ici on traite les dwords du dbut
Label03: mov ecx,ebx	;  placer la taille  copier dans ecx
and ecx,00000000000000000000000000001100b	;  ne conserver que les bits dwords en ecx
jz Label05	;  si ecx est gal  0, aller Label05
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
Label04: mov DWORD PTR [esi+ecx],0	;  placer 0 en esi+ecx
add ecx,4	;  on ajoute 4  ecx (notre pas de boucle)
jnz Label04	;  tant que ecx est diffrent de 0, aller Label04


;
; ici, c'est align alors on traite les 4x owords
;
Label05:
mov ecx,eax	;  placer la taille  copier dans ecx
and ecx,11111111111111111111111111000000b	;  ne conserver que les bits 4x owords en ecx
jz Label07	;  si ecx est gal  0, aller Label07
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
nop	;  alignement ncessaire pour un meilleur rendement
xorps XMM0,XMM0	;  effacer XMM0
Label06:
movaps OWORD PTR[esi+ecx],XMM0	;  placer 0 en esi+ecx
movaps OWORD PTR[esi+ecx+16],XMM0	;  placer 0 en esi+ecx+16
movaps OWORD PTR[esi+ecx+32],XMM0	;  placer 0 en esi+ecx+32
movaps OWORD PTR[esi+ecx+48],XMM0	;  placer 0 en esi+ecx+48
add ecx,64	;  on ajoute 64  ecx (notre pas de boucle)
jnz Label06	;  tant que ecx est diffrent de 0, aller Label06

; ici, on traite les owords
Label07: mov ecx,eax	;  placer la taille  copier dans ecx
and ecx,00000000000000000000000000110000b	;  ne conserver que les bits owords en ecx
jz Label09	;  si ecx est gal  0, aller Label09
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
xorps XMM0,XMM0	;  effacer XMM0
Label08:
movaps OWORD PTR[esi+ecx],XMM0	;  placer 0 en esi+ecx
add ecx,16	;  on ajoute 16  ecx (notre pas de boucle)
jnz Label08	;  tant que ecx est diffrent de 0, aller Label08

; ici, on traite les dwords
Label09: mov ecx,eax	;  placer la taille  copier dans ecx
and ecx,00000000000000000000000000001100b	;  ne conserver que les bits dwords en ecx
jz Label11	;  si ecx est gal  0, aller Label11
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
Label10: mov DWORD PTR [esi+ecx],0	;  placer 0 en esi+ecx
add ecx,4	;  on ajoute 4  ecx (notre pas de boucle)
jnz Label10	;  tant que ecx est diffrent de 0, aller Label10

; ici, on traite les octets
Label11: mov ecx,eax	;  placer la taille  copier dans ecx
and ecx,00000000000000000000000000000011b	;  ne conserver que les bits octets en ecx
jz Label13	;  si ecx est gal  0, aller Label13
add esi,ecx	;  on ajoute ecx  esi
neg ecx	;  inverser ecx
Label12: mov BYTE PTR [esi+ecx],0	;  placer 0 en esi+ecx
inc ecx	;  on ajoute 1  ecx (notre pas de boucle)
jnz Label12	;  tant que ecx est diffrent de 0, aller Label12

; enfin, on corrige les valeurs utilises pour retrouver les valeurs originelles
Label13: add eax,ebx	;  rajouter ebx  eax
sub esi,eax	;  soustraire la taille  esi (pour retrouver l'adresse originelle)

pop ecx	;  dsempiler ecx
pop ebx	;  dsempiler ebx
ret	;  retourner (sortir de la procdure)
Sse_ZeroMem_UnAligned ENDP

end start

OPT_SUSY WINDOWS
OPT_Cleanlst 0
OPT_Cleantmp 0
